<?php

namespace backend\modules\bhsx\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\bhsx\models\PembayaranKompetisi;

/**
 * PembayaranKompetisiSearch represents the model behind the search form about `backend\modules\bhsx\models\PembayaranKompetisi`.
 */
class PembayaranKompetisiSearch extends PembayaranKompetisi
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['pembayaran_id', 'peserta_kompetisi_id', 'deleted'], 'integer'],
            [['tanggal_pembayaran', 'bukti_pembayaran', 'status_pembayaran', 'created_at', 'updated_at', 'created_by', 'updated_by', 'deleted_at', 'deleted_by'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = PembayaranKompetisi::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'pembayaran_id' => $this->pembayaran_id,
            'peserta_kompetisi_id' => $this->peserta_kompetisi_id,
            'tanggal_pembayaran' => $this->tanggal_pembayaran,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
            'deleted' => $this->deleted,
            'deleted_at' => $this->deleted_at,
        ]);

        $query->andFilterWhere(['like', 'bukti_pembayaran', $this->bukti_pembayaran])
            ->andFilterWhere(['like', 'status_pembayaran', $this->status_pembayaran])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'updated_by', $this->updated_by])
            ->andFilterWhere(['like', 'deleted_by', $this->deleted_by]);

        return $dataProvider;
    }
}
